# typed: true

require 'faraday'
require 'nokogiri'
require 'sorbet-runtime'
require 'active_support'

#Define base module for orchestrating configuration of classes
module Setsuzoku

  autoload :ApiResponse, 'setsuzoku/api_response'
  autoload :HasConfigContext, 'setsuzoku/has_config_context'
  autoload :ApiStrategy, 'setsuzoku/api_strategy'
  autoload :AuthStrategy, 'setsuzoku/auth_strategy'
  autoload :Credential, 'setsuzoku/credential'
  autoload :Exception, 'setsuzoku/exception'
  autoload :ExternalApiHandler, 'setsuzoku/external_api_handler'
  autoload :Pluggable, 'setsuzoku/pluggable'
  autoload :Service, 'setsuzoku/service' #needs to load before plugin
  autoload :Plugin, 'setsuzoku/plugin'
  autoload :VERSION, 'setsuzoku/version'

  @@external_api_handler = ExternalApiHandler

  def self.external_api_handler
    @@external_api_handler
  end

  def self.external_api_handler=(val)
    @@external_api_handler = val
  end

  def self.configure
    yield(self)
  end
end