# typed: true

module Setsuzoku
  module Exception
    class InvalidAuthCredentials < StandardError
      def initialize(msg='The authentication credentials for this request are invalid.')
        super(msg)
      end
    end

    class UndefinedRequiredMethod < StandardError
      def initialize(registering_instance:, plugin_class:, method_name:)
        msg = "#{registering_instance.name} attempted to register #{plugin_class.name} but did not define the required instance method: #{method_name}"
        super(msg)
      end
    end
  end
end