# typed: true
# frozen_string_literal: true

module Setsuzoku
  # The base definition for the exception handling class.
  # This can be overridden by application configuration.
  class ExternalApiHandler
    def call_external_api_wrapper(**args)
      puts('Setsuzoku API call pending')
      response = yield
      puts("Setsuzoku API call complete. Success status: #{response[:success]}")
    end

    def call_external_api_exception(**args)
      puts(args[:exception].backtrace.join("\n")) if args[:exception]
      puts("call_external_api failed with: #{args.inspect}")
    end
  end
end