# typed: strict
# frozen_string_literal: true

require 'setsuzoku/service/web_service/api_strategy'
require 'setsuzoku/service/web_service/auth_strategy'
require 'setsuzoku/service/web_service/service'
require 'setsuzoku/service/web_service/api_strategies/rest_strategy'
require 'setsuzoku/service/web_service/api_strategies/rest_api_request'
require 'setsuzoku/service/web_service/auth_strategies/strategy_can_use_tokens'
require 'setsuzoku/service/web_service/auth_strategies/basic_auth_strategy'
require 'setsuzoku/service/web_service/auth_strategies/custom_auth_strategy'
require 'setsuzoku/service/web_service/auth_strategies/o_auth_strategy'
require 'setsuzoku/service/web_service/credentials/uses_credential_token'
require 'setsuzoku/service/web_service/credentials/basic_auth_credential'
require 'setsuzoku/service/web_service/credentials/custom_auth_credential'
require 'setsuzoku/service/web_service/credentials/o_auth_credential'

module Setsuzoku
  module Service
    module WebService
      # Core service required for a web service plugin.
      # It should be able to register all of its available api and auth strategies.
    end
  end
end